'use strict'
// @ts-check

const { Sequelize } = require('@fizz.js/node-model/libs')
const {
  Model,
  DataTypes
} = Sequelize
const Logger = require('@fizz.js/node-logger/libs')
const CONSTANT = require('@fizz.js/node-constant/libs')

/**
 *
 *
 * @class Model{{CLAZZ}}
 * @extends {Model}
 */
class Model{{CLAZZ}} extends Model {
  /**
   *
   *
   * @static
   * @param {*} sequelize
   * @returns {Model{{CLAZZ}}}
   * @memberof Model{{CLAZZ}}
   */
  static init(sequelize) {
    return super.init({
{{FIELDS}}
    }, {
      modelName: '{{MODEL}}',
      tableName: '{{TABLE}}',
      underscored: false,
      paranoid: true,
      sequelize
    })
  }

  /**
   * @example `this.belongsTo(models.your_models)` and also add into target model `this.hasMany(models.your_target_models)` or `this.hasOne(models.your_target_models)`
   * @static
   * @param {*} models
   * @memberof Model{{CLAZZ}}
   */
  static associate(models) {
{{RELATIONS}}
  }

  /**
   *
   *
   * @static
   * @param {string} [status=CONSTANT.STATUS.ACTIVE]
   * @returns {Model{{CLAZZ}}[]}
   * @memberof Model{{CLAZZ}}
   */
  static async findAllByStatus(status = CONSTANT.STATUS.ACTIVE) {
    try {
      const condition = {
        where: {
          status
        }
      }

      /** @type {Model{{CLAZZ}}[]} */
      return await this.findAll(condition)
    } catch (error) {
      Logger.error(error)
      throw error
    }
  }

  /**
   *
   *
   * @static
   * @param {number} id
   * @param {string} [status=CONSTANT.STATUS.ACTIVE]
   * @returns {Model{{CLAZZ}}}
   * @memberof Model{{CLAZZ}}
   */
  static async findById(id, status = CONSTANT.STATUS.ACTIVE) {
    try {
      const condition = {
        where: {
          id,
          status
        }
      }

      /** @type {Model{{CLAZZ}}} */
      return await this.findOne(condition)
    } catch (error) {
      Logger.error(error)
      throw error
    }
  }
}

module.exports = Model{{CLAZZ}}
