'use strict'
// @ts-check

const config = require('config')
const Authenticate = require('@fizz.js/node-authenticate/libs')
const auth = new Authenticate()
const Context = require('@fizz.js/node-context/libs')
const {{CLAZZ}}Controller = require('../controllers/{{SINGULAR}}')
const Controller = new {{CLAZZ}}Controller()

/**
 *
 * @returns {IRouteParams}
 */
module.exports = {
  list: {
    method: 'get',
    path: `/${config.endpoint.private}/{{PLURAL}}`,
    middlewares: [
      Context.validateAnyScope.bind(Context),
      auth.authenticate.bind(auth),
      Controller.validationMiddleware('getAll'),
    ],
    controller: Controller.getAll.bind(Controller),
  },
  getOne: {
    method: 'get',
    path: `/${config.endpoint.private}/{{PLURAL}}/:id(\\d+)`,
    middlewares: [
      Context.validateAnyScope.bind(Context),
      auth.authenticate.bind(auth),
      Controller.validationMiddleware('getOne'),
    ],
    controller: Controller.getOne.bind(Controller),
  },
  create: {
    method: 'post',
    path: `/${config.endpoint.private}/{{PLURAL}}`,
    middlewares: [
      Context.validateAnyScope.bind(Context),
      auth.authenticate.bind(auth),
      Controller.validationMiddleware('create'),
    ],
    controller: Controller.create.bind(Controller),
  },
  update: {
    method: 'patch',
    path: `/${config.endpoint.private}/{{PLURAL}}/:id(\\d+)`,
    middlewares: [
      Context.validateAnyScope.bind(Context),
      auth.authenticate.bind(auth),
      Controller.validationMiddleware('update'),
    ],
    controller: Controller.update.bind(Controller),
  },
  delete: {
    method: 'delete',
    path: `/${config.endpoint.private}/{{PLURAL}}/:id(\\d+)`,
    middlewares: [
      Context.validateAnyScope.bind(Context),
      auth.authenticate.bind(auth),
      Controller.validationMiddleware('destroy'),
    ],
    controller: Controller.destroy.bind(Controller),
  },
}
