'use strict'
// @ts-check

const MongoDB = require('@fizz.js/node-mongodb/libs')
const {
  STATUS
} = require('@fizz.js/node-constant/libs')
const definition = {
  name: {
    required: true,
    unique: true,
    type: MongoDB.types.String,
    trim: true,
    lowercase: false,
    uppercase: false,
    default: 'N/A',
    select: true,
  },
  status: {
    required: true,
    unique: false,
    type: MongoDB.types.String,
    enum: {
      values: [STATUS.ACTIVE, STATUS.INCTIVE, STATUS.PENDING]
    },
    default: STATUS.PENDING,
    trim: true,
    lowercase: true,
    uppercase: false,
    select: true,
  }
}

const schema = MongoDB.createSchema(definition)
module.exports = schema
